
"use strict";

(function() {

  let timer = null;

  /**
   * Add a function that will be called when the window is loaded.
   */
  window.addEventListener("load", init);

  /**
   * CHANGE: Describe what your init function does here.
   */
  function init() {
    /* Question 5 */
    id("message").visibility = false;
    id("plant").addEventListener("click", plantPumpkins);

    // Mention that this would be added to set up the buttons for question 6.
    initTimerButtons();
  }

  /* Given for Question 6 */
  function initTimerButtons() {
    id("start").addEventListener("click", startRotting);
    id("stop").addEventListener("click", stopRotting);

  //  id("start").disabled = true;
  //  id("stop").disabled = true;
  }

  /* Question 5 */
  function plantPumpkins() {
    // get the value from the count field
    let count = parseInt(id("count").value);
    if (count >=  1) {
      loadPumpkins(count);
    }
    else {
      showMessage("Enter a positive integer", 2000);  // short message for exam
    }
  }

  /* Question 5 */
  function loadPumpkins(number) {
    const pumpkinTypes = ["happy", "sad", "goofy"];

    for (let i = 0; i < number; i++) {
      let rand = Math.floor(Math.random() * pumpkinTypes.length);
      let newPumpkin = gen("div");
      newPumpkin.classList.add("pumpkin");
      newPumpkin.classList.add(pumpkinTypes[rand]);

      /* specify that newPumpkin location comes back as JSON object, you can set the
       * top and left in this way.. in specification */

      let location = newPumpkinLocation();
      newPumpkin.style.left = location.left;
      newPumpkin.style.top = location.top;


      id("patch").appendChild(newPumpkin);
      newPumpkin.addEventListener("click", removePumpkin);
    }

    /* hand wave and not deal with this */
    if (timer === null) {
      id("start").disabled = false;
    }
  }

  function removePumpkin(event) {
    let object = event.currentTarget;
    object.removeEventListener("click", removePumpkin);
    object.parentNode.removeChild(object);
  }


  /** The spec for this will be given to students (with the code not shown)
   */
  function newPumpkinLocation() {
    const pumpkinWidth = 40;
    const pumpkinHeight = 30;

    let style = window.getComputedStyle(id("patch"));
    let xFromLeft = Math.random() * (parseInt(style.width) - pumpkinWidth);
    let yFromTop = Math.random() * (parseInt(style.height) - pumpkinHeight);
    let location = {};
    location.left = Math.floor(xFromLeft) + "px";
    location.top = Math.floor(yFromTop) + "px";
    return location;

  }


  /* Implement in question 6, but in question 5, they can assume this works as expected 4 pts*/
  function showMessage(message, time) {
    id("message").classList.remove("hidden");
    id("message").textContent =  message;
    setTimeout(function() {
      id("message").textContent = "";
      id("message").classList.add("hidden");
    }, time);
  }


  /* write in question 6 3 pts*/
  function startRotting() {
    id("start").disabled = true;
    id("stop").disabled = false;

    timer = setInterval(rotPumpkins, 2000);
  }

  /* write in question 6 3 pt */
  function rotPumpkins() {
    let pumpkins = qsa(".pumpkin");
    for (let i = 0; i < pumpkins.length; i++) {
        rotAPumpkin(pumpkins[i]);
    }

  }

  // this is abstracted away
  function rotAPumpkin(el) {

    if (el.classList.contains("rotting1")) {
      el.classList.toggle("rotting1");
      el.classList.toggle("rotting2");
    }
    else if (el.classList.contains("rotting2")) {
      el.classList.toggle("rotting2");
      el.classList.toggle("rotting3");
    }
    else if (el.classList.contains("rotting3")) {
      el.parentNode.removeChild(el);
    }
    else if (!el.classList.contains("rotting1", "rotting2", "rotting3")) {
      el.classList.add("rotting1");
    }
  }

  function stopRotting() {
    id("start").disabled = false;
    id("stop").disabled = true;
    clearInterval(timer);
    timer = 0;
  }



  /**
   * Returns the element that has the ID attribute with the specified value.
   * @param {string} idName - element ID
   * @returns {object} DOM object associated with id.
   */
  function id(idName) {
    return document.getElementById(idName);
  }

  /**
   * Returns the first element that matches the given CSS selector.
   * @param {string} selector - CSS query selector.
   * @returns {object} The first DOM object matching the query.
   */
  function qs(selector) {
    return document.querySelector(selector);
  }

  /**
   * Returns the array of elements that match the given CSS selector.
   * @param {string} selector - CSS query selector
   * @returns {object[]} array of DOM objects matching the query.
   */
  function qsa(selector) {
    return document.querySelectorAll(selector);
  }

  /**
   * Returns a new element with the given tag name.
   * @param {string} tagName - HTML tag name for new DOM element.
   * @returns {object} New DOM object for given HTML tag.
   */
  function gen(tagName) {
    return document.createElement(tagName);
  }


})();
